<template>
  <div class="content">
    <img alt="Vue logo" src="@/assets/logo.png" width="1000" />
    <DotsLoader v-if="isLoading" />
    <UserComponent v-else />
  </div>
</template>

<script setup>
import { keycloak } from "@/plugins/keycloak.js";
import UserComponent from "@/components/UserComponent.vue";

import DotsLoader from "@/components/DotsLoader";

import { ref, onMounted } from "vue";
import { useRouter, useRoute } from "vue-router";

const router = useRouter();
const route = useRoute();

const isLoading = ref(false);

onMounted(async () => {
  isLoading.value = true;
  await keycloak
    .init({
      onLoad: "login-required", // TODO рассказать разницу между значениями и как это работает технически
    })
    .then((auth) => {
      if (!auth) {
        window.location.reload();
      } else {
        console.log(keycloak.token);
        console.log("Authenticated");
      }
    })
    .catch(() => {
      console.error("Failed to initialize Keycloak");
    });

  isLoading.value = false;

  // Ань, у меня роль app , а не ROLE_app
  if (route.meta.authenticated && !keycloak.hasRealmRole("app")) {
    router.push({ name: "Error" });
  }

  // console.log(keycloak.hasRealmRole("app"), "if user has accsess");
});
</script>

<style>
.content {
  min-height: calc(100vh - 105px);
}
</style>
